---
title: debugger
slug: Web/JavaScript/Reference/Statements/debugger
tags:
  - JavaScript
  - Language feature
  - Statement
---
<div>{{jsSidebar("Statements")}}</div>

<p>The <strong><code>debugger</code> statement</strong> invokes any available debugging functionality, such as setting a breakpoint. If no debugging functionality is available, this statement has no effect.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">debugger;</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Using_the_debugger_statement">Using the debugger statement</h3>

<p>The following example shows code where a <code>debugger</code> statement has been inserted, to invoke a debugger (if one exists) when the function is called.</p>

<pre class="brush:js notranslate">function potentiallyBuggyCode() {
    debugger;
    // do potentially buggy stuff to examine, step through, etc.
}</pre>

<p>When the debugger is invoked, execution is paused at the <code>debugger</code> statement. It is like a breakpoint in the script source.</p>

<p><a href="https://mdn.mozillademos.org/files/6963/Screen%20Shot%202014-02-07%20at%209.14.35%20AM.png"><img alt="Paused at a debugger statement." src="https://mdn.mozillademos.org/files/6963/Screen%20Shot%202014-02-07%20at%209.14.35%20AM.png" style="height: 371px; width: 700px;"></a></p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-debugger-statement', 'Debugger statement')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.statements.debugger")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Mozilla/Debugging/Debugging_JavaScript">Debugging JavaScript</a></li>
 <li><a href="/en-US/docs/Tools/Debugger">The Debugger in the Firefox Developer Tools</a></li>
</ul>
